Index: src/backend/commands/tablecmds.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/tablecmds.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.8.22
diff -c -r1.1.1.2 -r1.1.1.2.8.22
*** src/backend/commands/tablecmds.c	1 Dec 2008 09:37:46 -0000	1.1.1.2
--- src/backend/commands/tablecmds.c	19 Mar 2009 12:34:56 -0000	1.1.1.2.8.22
***************
*** 3443,3448 ****
--- 3600,4910 ----
  	}
  }
  
+ /*
+  * IsValidRange : Check if the given range has values of valid types and 
+  *	min value is less than max value.
+  */
+ static bool 
+ IsValidRange(ListCell *minIndex, ListCell *maxIndex, Oid parentRelOid, char *partitionColumn, char *tableName)
+ {
+ 
+ 	Oid 		typ_oid;
+ 	int16		len;
+ 	bool		typbyval;
+ 	Node		*expr;
+ 	StringInfo	cbuf = makeStringInfo();
+ 	Datum		min_datum;
+ 	Datum		max_datum;
+ 	Oid			keycmp_oid;
+ 	bool		isdef;
+ 	Oid			keycmp_proc;
+ 	bool		lt_max;
+ 
+ 	/* Get the attribute type. */
+ 	typ_oid = get_atttype(parentRelOid, get_attnum(parentRelOid, partitionColumn));
+ 
+ 	/* Get the attribute length*/
+ 	get_typlenbyval(typ_oid, &len, &typbyval);
+ 
+ 	if(minIndex == NULL || maxIndex == NULL)
+ 		elog(ERROR, "Please specify the values for '%s' attribute of '%s' partition.", partitionColumn, tableName);
+ 
+ 	/* Transform the expression from "A_Expr" type to "OpExpr" type. This is needed
+ 	as expression evaluation does not happen at parser level. */
+ 	expr = transformExpr(NULL, (Node *)lfirst(minIndex));
+ 
+ 	/* Solve the expression. */
+ 	lfirst(minIndex) = eval_const_expressions(NULL, expr);
+ 
+ 	/* Convert the value to column's datatype. */
+ 	lfirst(minIndex) = coerce_to_specific_type(NULL, lfirst(minIndex), typ_oid, partitionColumn);
+ 
+ 	resetStringInfo(cbuf);
+ 
+ 	/* If it's a FuncExpr then execute the conversion function. */
+ 	if IsA((Node *)lfirst(minIndex), FuncExpr)
+ 	{
+ 		min_datum = OidFunctionCall1(((FuncExpr *)lfirst(minIndex))->funcid,
+ 						((Const *)lfirst(list_head(((FuncExpr *)lfirst(minIndex))->args)))->constvalue);
+ 		/* Store the datums back. */
+ 		((Const *)lfirst(minIndex))->constvalue = min_datum;
+ 	}
+ 	else
+ 	{
+ 		min_datum = ((Const *)lfirst(minIndex))->constvalue;
+ 	}
+ 
+ 	/* Transform the expression from "A_Expr" type to "OpExpr" type. This is needed
+ 	as expression evaluation does not happen at parser level. */
+ 	expr = transformExpr(NULL, (Node *)lfirst(maxIndex));
+ 
+ 	/* Solve the expression. */
+ 	lfirst(maxIndex) = eval_const_expressions(NULL, expr);
+ 
+ 	/* Convert the value to column's datatype. */
+ 	lfirst(maxIndex) = coerce_to_specific_type(NULL, lfirst(maxIndex), typ_oid, partitionColumn);
+ 
+ 	resetStringInfo(cbuf);
+ 
+ 	/* If it's a FuncExpr then execute the conversion function. */
+ 	if IsA((Node *)lfirst(maxIndex), FuncExpr)
+ 	{
+ 		max_datum = OidFunctionCall1(((FuncExpr *)lfirst(maxIndex))->funcid,
+ 						((Const *)lfirst(list_head(((FuncExpr *)lfirst(maxIndex))->args)))->constvalue);
+ 		/* Store the datums back. */
+ 		((Const *)lfirst(maxIndex))->constvalue = max_datum;
+ 	}
+ 	else
+ 	{
+ 		max_datum = ((Const *)lfirst(maxIndex))->constvalue;
+ 	}
+ 
+ 	keycmp_oid = OperatorGet("<", PG_CATALOG_NAMESPACE , typ_oid, typ_oid, &isdef);
+ 
+ 	if(isdef == FALSE)
+ 		elog(ERROR, "'<' operator is not defined for this type.");
+ 
+ 	keycmp_proc = get_opcode(keycmp_oid);
+ 	lt_max = DatumGetBool(OidFunctionCall2(keycmp_proc, min_datum, max_datum));
+ 
+ 	if(lt_max == 0)
+ 	{
+ 		if(tableName)
+ 		{
+ 			elog(ERROR, "First value should be less then second value for '%s' attribute of partition '%s'.",
+ 					partitionColumn, tableName);
+ 		}
+ 		else
+ 		{
+ 			elog(ERROR, "First value should be less then second value for '%s' attribute.",
+ 					partitionColumn);
+ 		}
+ 	}
+ 
+ 	return lt_max;
+ }
+ 
+ static bool
+ WriteRangePartitionToCatalog(Datum min_datum,
+ 								Datum max_datum,
+ 								int16 len,
+ 								bool typbyval,
+ 								Oid parentRelOid,
+ 								Oid	partRelOid,
+ 								int	attNum,
+ 								Oid typ_oid,
+ 								int keyOrder)
+ {
+ 
+ 	bytea 			*min_ba, *max_ba;
+ 	Datum 			values[Natts_pg_partition];
+ 	bool  			nulls [Natts_pg_partition];
+ 	int				i;
+ 
+ 	/* initialize nulls and values */
+ 	for (i = 0; i < Natts_pg_partition; i++)
+ 	{
+ 		nulls[i] = false;
+ 		values[i] = (Datum) NULL;
+ 	}
+ 
+ 	/* There are 3 cases here
+ 	 * 1. types with length = -1
+ 	 * 2. types with fixed length but passed by value (len < 4)
+ 	 * 3. types with fixed length but *not* passed by value (len > 4)
+ 	 */
+ 	if(len > 0)
+ 	{
+ 		min_ba = (bytea *) palloc(len+1+VARHDRSZ);
+ 		max_ba = (bytea *) palloc(len+1+VARHDRSZ);
+ 
+ 		if(typbyval)
+ 		{
+ 			memcpy(VARDATA(min_ba), &min_datum, len);
+ 			memcpy(VARDATA(max_ba), &max_datum, len);
+ 		}
+ 		else
+ 		{
+ 			memcpy(VARDATA(min_ba), (char *)min_datum, len);
+ 			memcpy(VARDATA(max_ba), (char *)max_datum, len);
+ 		}
+ 
+ 		SET_VARSIZE(min_ba, len+VARHDRSZ);
+ 		VARDATA(min_ba)[len] = '\0';
+ 		values[Anum_pg_partition_minval        -1]= (Datum)min_ba ;
+ 
+ 		SET_VARSIZE(max_ba, len+VARHDRSZ);
+ 		VARDATA(max_ba)[len] = '\0';
+ 		values[Anum_pg_partition_maxval        -1]=(Datum)max_ba;
+ 	}
+ 	else
+ 	{
+ 		values[Anum_pg_partition_minval        -1]=min_datum;
+ 		values[Anum_pg_partition_maxval        -1]=max_datum;
+ 	}
+ 
+ 	values[Anum_pg_partition_parentrelid -1]= ObjectIdGetDatum(parentRelOid);
+ 	values[Anum_pg_partition_partrelid  -1] = ObjectIdGetDatum(partRelOid);
+ 	values[Anum_pg_partition_parttype   -1] = Int8GetDatum(PART_RANGE);
+ 	values[Anum_pg_partition_partkey    -1] = ObjectIdGetDatum(attNum);
+ 	values[Anum_pg_partition_listval    -1] = Int8GetDatum(NULL);
+ 	nulls[Anum_pg_partition_listval     -1] = true;
+ 	values[Anum_pg_partition_hashval    -1] = Int8GetDatum(NULL);
+ 	nulls[Anum_pg_partition_hashval     -1] = true;
+ 	values[Anum_pg_partition_keytype    -1] = ObjectIdGetDatum(typ_oid);
+ 	values[Anum_pg_partition_keyorder   -1] = Int8GetDatum(keyOrder);
+ 
+ 	Relation r = heap_open(PartitionRelationId, RowExclusiveLock);
+ 	TupleDesc tupDesc = r->rd_att;
+ 	HeapTuple tup = heap_form_tuple(tupDesc, values, nulls);
+ 	simple_heap_insert(r, tup);
+ 	CatalogUpdateIndexes(r, tup); 
+     heap_close(r, RowExclusiveLock);
+ 	
+ 	return true;
+ }
+ 
+ static char* 
+ DisplayDatum(Datum datum, Oid type)
+ {
+ 	Oid		typeOut;
+ 	bool	isVariableLength;
+ 
+ 	getTypeOutputInfo(type, &typeOut, &isVariableLength);
+ 	return (DatumGetCString(OidFunctionCall1(typeOut, datum)));
+ }
+ 
+ static void 
+ AddCheckConstraint(Oid typ_oid, Datum min_datum, Datum max_datum, char *tableName, char *partitionColumn)
+ {
+ 	char		*expr_string;
+ 	StringInfo	func_constraint = makeStringInfo();
+ 	Oid			typoutput;
+ 	bool		isVariableLength;
+ 	List		*query_list;
+ 	Node		*parsetree;
+ 	
+ 
+ 	resetStringInfo(func_constraint);
+ 
+ 	getTypeOutputInfo(typ_oid, &typoutput, &isVariableLength);
+ 	expr_string = DatumGetCString(OidFunctionCall1(typoutput, min_datum));
+ 
+ 	/* Form the check constraint for child table. */
+ 	appendStringInfo(func_constraint, "ALTER TABLE %s ADD CHECK ( %s >= '%s' ",
+ 		tableName,
+ 		partitionColumn,
+ 		expr_string);
+ 
+ 	expr_string = DatumGetCString(OidFunctionCall1(typoutput, max_datum));
+ 	appendStringInfo(func_constraint, " AND %s < '%s' ); ",
+ 		partitionColumn,
+ 		expr_string);
+ 		
+ 	/* Parse the above SQL string and use this parsetree to create check constraint on child tables. */
+ 	query_list  = pg_parse_query(func_constraint->data);
+ 	parsetree = (Node *)lfirst(list_head(query_list));
+ 	AlterTable(( AlterTableStmt * )parsetree);			
+ 
+ }
+ 
+ static Datum 
+ GetDatum(Relation rel, Oid type, HeapTuple tuple, int column)
+ {
+ 	Datum		datum;
+ 	int16 		len;
+ 	bool		typeByVal;
+ 	bool		isNull;
+ 
+ 	/* Get len and typbyval from pg_type */
+ 	get_typlenbyval(type, &len, &typeByVal);
+ 
+ 	/* Get min attribute from catalog */
+ 	datum = heap_getattr (tuple, column, rel->rd_att, &isNull);
+ 
+ 	/* Three cases 
+ 	 * a. datatypes with typbyval true and fix length.
+ 	 * b. datatypes with byval false and fix length.
+ 	 * c. extendible datatypes where length -1.
+ 	 */
+ 	if (typeByVal)
+ 	{
+ 		memcpy(&datum, VARDATA_ANY(datum), len);
+ 	}
+ 	else if (len != -1)
+ 	{
+ 		datum = (Datum)VARDATA_ANY(datum);
+ 	}	
+ 	
+ 	return datum;
+ }
+ 
+ static Datum 
+ EvalExpr(ListCell *node, Oid type, char *colName)
+ {
+ 	Node 	*expr;
+ 	Datum 	datum;
+ 
+ 	/* Transform the expression from "A_Expr" type to "OpExpr" type. This is needed
+ 	as expression evaluation does not happen at parser level. */
+ 	expr = transformExpr(NULL, (Node *)lfirst(node));
+ 
+ 	/* Solve the expression. */
+ 	lfirst(node) = eval_const_expressions(NULL, expr);
+ 
+ 	/* Convert the value to column's datatype. */
+ 	lfirst(node) = coerce_to_specific_type(NULL, lfirst(node), type, colName);
+ 
+ 	/* If it's a FuncExpr then execute the conversion function. */
+ 	if IsA((Node *)lfirst(node), FuncExpr)
+ 	{
+ 		datum = OidFunctionCall1(((FuncExpr *)lfirst(node))->funcid,
+ 						((Const *)lfirst(list_head(((FuncExpr *)lfirst(node))->args)))->constvalue);
+ 		/* Store the datums back. */
+ 		((Const *)lfirst(node))->constvalue = datum;
+ 	}
+ 	else
+ 	{
+ 		datum = ((Const *)lfirst(node))->constvalue;
+ 	}
+ 
+ 	return datum;
+ }
+ 
+ static bool 
+ OperateDatums(char *operatorName, Oid type, Datum datum1, Datum datum2)
+ {
+ 	bool 			isDef;
+ 	bool 			result;
+ 	Oid  			operator;
+ 	Oid	 			opcode;
+ 
+ 	operator = OperatorGet(operatorName, PG_CATALOG_NAMESPACE , type, type, &isDef);
+ 
+ 	if(isDef == FALSE)
+ 		elog(ERROR, "'%s' operator is not defined for this type.", operatorName);
+ 
+ 	opcode = get_opcode(operator);
+ 	result = DatumGetBool(OidFunctionCall2(opcode, datum1, datum2));
+ 
+ 	return result;
+ }
+ 
+ static void 
+ ATExecSplitPartition(AlteredTableInfo *tab, Relation rel,
+ 	SplitPartitionStmt *part)
+ {
+ 	Oid 			relId;
+ 	ScanKeyData		skey;
+ 	Relation		pg_partrel;
+ 	SysScanDesc		pg_partscan;
+ 	HeapTuple		pg_parttup;
+ 	Datum 			minDatum;
+ 	Datum			maxDatum;
+ 	ListCell		*node;
+ 	char			*columnName;
+ 	Partition		*partition2 = NULL;
+ 	Partition		*partition1 = NULL;
+ 	Const			*cnst;
+ 	int16			len;
+ 	bool			typeByVal;
+ 	StringInfo		query = makeStringInfo();
+ 	List			*queryList;
+ 	Node			*parseTree;
+ 	Oid				backup;
+ 	
+ 	/* Get the relId from the tablename. */
+ 	if(list_head(part->partNames))
+ 	{
+ 		relId  = RelnameGetRelid(((RangeVar *)linitial(part->partNames))->relname);
+ 		if (relId == InvalidOid)
+ 			elog(ERROR, "Error : Could not find valid Rel-Id for '%s' in current search path.", ((RangeVar *)linitial(part->partNames))->relname);
+ 	}
+ 	else
+ 	{
+ 		elog(ERROR, "Please specify valid partition to be updated.");
+ 	}
+ 
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_partrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(relId));
+ 
+     pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         if(pg_part->parttype == PART_RANGE)
+         {
+ 			/* Fetch the min and max value for given attribute of partition. */
+ 			minDatum = GetDatum(pg_partrel, pg_part->keytype, pg_parttup, Anum_pg_partition_minval);
+ 			maxDatum = GetDatum(pg_partrel, pg_part->keytype, pg_parttup, Anum_pg_partition_maxval);
+ 
+ 			if(pg_part->keyorder == 1)
+ 			{
+ 				partition1					= makeNode(Partition);
+ 				partition1->partName 		= makeNode(RangeVar);
+ 				partition1->partitionCheck	= makeNode(Constraint);
+ 
+ 				partition2					= makeNode(Partition);
+ 				partition2->partName 		= makeNode(RangeVar);
+ 				partition2->partitionCheck	= makeNode(Constraint);
+ 
+ 				partition1->partName		= (RangeVar *)lsecond(part->partNames);
+ 				partition1->partitionCheck->max_value = part->splitValues;
+ 
+ 				partition2->partName		= (RangeVar *)lthird(part->partNames);
+ 				partition2->partitionCheck->min_value = part->splitValues;
+ 
+ 				node = list_head(part->splitValues);
+ 			}
+ 
+ 			/* Get the column name. */
+ 			columnName = get_attname (relId, pg_part->partkey);
+ 		
+ 			EvalExpr(node, pg_part->keytype, columnName);
+ 			DisplayDatum(((Const *)lfirst(node))->constvalue, pg_part->keytype);
+ 
+ 			if((OperateDatums(">", pg_part->keytype, ((Const *)lfirst(node))->constvalue, minDatum) == false) ||
+ 				(OperateDatums("<", pg_part->keytype, ((Const *)lfirst(node))->constvalue, maxDatum) == false))
+ 			{
+ 				elog(ERROR, "Split-point is not valid. Value for '%s' attribute should be in-between and excluding '%s' and '%s'.", columnName, 
+ 					DisplayDatum(minDatum, pg_part->keytype), DisplayDatum(maxDatum, pg_part->keytype));
+ 			}
+ 		
+ 			/* Get len and typbyval from pg_type */
+ 			get_typlenbyval(pg_part->keytype, &len, &typeByVal);
+ 
+ 			/* Form the const node out of datums. */
+ 			cnst = makeConst(pg_part->keytype,
+ 						-1,
+ 						len,
+ 						maxDatum,
+ 						false,
+ 						typeByVal);
+ 
+ 			cnst->location = -1;
+ 
+ 			partition2->partitionCheck->max_value = lappend(partition2->partitionCheck->max_value, cnst);
+ 
+ 			/* Form the const node out of datums. */
+ 			cnst = makeConst(pg_part->keytype,
+ 						-1,
+ 						len,
+ 						minDatum,
+ 						false,
+ 						typeByVal);
+ 
+ 			cnst->location = -1;
+ 
+ 			partition1->partitionCheck->min_value = lappend(partition1->partitionCheck->min_value, cnst);
+ 
+ 			node = lnext(node);
+ 
+ 			/* Delete the entry for current table.*/
+ 			simple_heap_delete(pg_partrel, &pg_parttup->t_self);	
+ 			CatalogUpdateIndexes(pg_partrel, pg_parttup); 
+ 		}
+ 	}
+ 
+     systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, RowExclusiveLock);
+ 
+ 	ATExecAddPartition(tab, rel, partition1);
+ 	backup = ATExecAddPartition(tab, rel, partition2);
+ 
+ 	if((partition1 != NULL) && (partition2 != NULL))
+ 	{
+ 		Snapshot		snap;
+ 		Relation 		tmpRel;
+ 		HeapScanDesc	scanDesc;
+ 		HeapTuple		tuple;
+ 		Oid				relation_id;
+ 		Relation		child_table_relation;
+ 
+ 		snap = GetActiveSnapshot();
+ 		tmpRel 	= heap_open(relId, RowExclusiveLock);
+ 		scanDesc = heap_beginscan(tmpRel, snap, 0, NULL);
+ 
+     	while (HeapTupleIsValid(tuple = heap_getnext(scanDesc, ForwardScanDirection)))
+ 		{
+ 
+ 			relation_id = get_relevent_partition(tuple, rel);
+ 
+ 			if (relation_id == InvalidOid)
+ 				relation_id = backup;
+ 
+ 			child_table_relation = RelationIdGetRelation(relation_id);
+ 
+ 			if (child_table_relation != NULL)
+ 			{
+ 
+ 			ResultRelInfo *resultRelInfo;
+ 			TupleTableSlot *slot;
+ 			EState *estate= CreateExecutorState();
+ 
+ 			resultRelInfo = makeNode(ResultRelInfo);
+ 			resultRelInfo->ri_RangeTableIndex = 1;
+ 			resultRelInfo->ri_RelationDesc = child_table_relation;
+ 
+ 			estate->es_result_relations = resultRelInfo;
+ 			estate->es_num_result_relations = 1;
+ 			estate->es_result_relation_info = resultRelInfo;
+ 
+ 			/* Set up a tuple slot too */
+ 			slot = MakeSingleTupleTableSlot(rel->rd_att);
+ 			ExecStoreTuple(tuple, slot, InvalidBuffer, false);
+ 
+ 			ExecConstraints(resultRelInfo, slot, estate);
+ 
+ 			heap_insert(child_table_relation, tuple, GetCurrentCommandId(true), 0, NULL);
+ 			RelationClose(child_table_relation);
+ 			ExecDropSingleTupleTableSlot(slot);
+ 			FreeExecutorState (estate);
+ 			}
+ 			else
+ 			{
+ 				elog(ERROR, "Could not migrate row.");
+ 			}
+ 			
+ 		}
+ 		
+ 		heap_endscan(scanDesc);
+ 		heap_close(tmpRel, RowExclusiveLock);
+ 
+ 		/* clear the buffer. */
+ 		resetStringInfo(query);
+ 
+ 		appendStringInfo(query, "DROP TABLE %s CASCADE;", ((RangeVar *)linitial(part->partNames))->relname);
+ 		queryList = pg_parse_query(query->data);
+ 		parseTree = (Node *)lfirst(list_head(queryList));
+ 		RemoveRelations((DropStmt *)parseTree);
+ 	}
+ }
+ 
+ static void 
+ ATExecUpdatePartition(AlteredTableInfo *tab, Relation rel,
+ 	UpdatePartitionStmt *part)
+ {
+ 	Oid				relId;
+ 	ScanKeyData 	skey;
+ 	Relation		pg_partrel;
+ 	SysScanDesc		pg_partscan;
+ 	HeapTuple		pg_parttup;
+ 	ListCell		*minIndexPrev, *minIndexAfter;
+ 	ListCell		*maxIndexPrev, *maxIndexAfter;
+ 	char			*partitionColumn;
+ 	Oid				keycmp_oid;
+ 	bool			isdef;
+ 	Oid				keycmp_proc;
+ 	bool			gte_max, lte_min;
+ 	List			*distinct_part_rel_oid_list = NULL;
+ 	List			*distinct_part_key_list = NULL;
+ 	Oid				*childOids;
+ 	int				j = 0;
+ 	Partition		*tmp;	
+ 	PartitionAttrs	*partition_attr;
+ 	int16			len;
+ 	bool			typbyval;
+ 	Datum			part_attr;
+ 	bool			isnull;
+ 	Datum			short_datum;
+ 	Const			*tmp_const;
+ 	int				keyorder;
+ 	Oid				typ_oid;
+ 	StringInfo		func_constraint = makeStringInfo();
+ 	List			*query_list;
+ 	Node			*parsetree;
+ 
+ 	/* Get the relId from the tablename. */
+ 	if(part->prev->partName->relname)
+ 	{
+ 		relId  = RelnameGetRelid(part->prev->partName->relname);
+ 		if (relId == InvalidOid)
+ 			elog(ERROR, "Error : Could not find valid Rel-Id for '%s' in current search path.", part->prev->partName->relname);
+ 		part->after->partName = part->prev->partName;
+ 	}
+ 	else
+ 	{
+ 		elog(ERROR, "Please specify valid partition to be updated.");
+ 	}
+ 
+ 	childOids = malloc(sizeof(Oid)*GetPartitionsCount(RelationGetRelid(rel))); 
+ 
+ 	ScanKeyInit(&skey,
+ 		Anum_pg_partition_parentrelid,
+ 		BTEqualStrategyNumber, F_OIDEQ,
+ 		ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+ 	pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+ 	pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+ 					SnapshotNow, 1, &skey);
+ 
+ 	/* Create partition attribute node. */
+ 	partition_attr = makeNode(PartitionAttrs);
+  
+ 	while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+ 		/* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+ 		Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		if(pg_part->parttype == PART_RANGE)
+ 		{
+ 
+ 			if (!list_member_int(distinct_part_key_list, pg_part->partkey))
+ 			{
+ 				Alias *colName;
+ 
+ 				distinct_part_key_list = lappend_int(distinct_part_key_list, pg_part->partkey);
+ 
+ 				/* Get the name of partition key column */
+ 				partitionColumn = get_attname (rel->rd_id, pg_part->partkey);
+ 
+ 				/* Add the partition key columns. */
+ 				colName = makeAlias(partitionColumn, NULL);
+ 				partition_attr->colName = lappend(partition_attr->colName, colName);								
+ 			}
+ 
+ 			if(relId == pg_part->partrelid)
+ 			{
+ 				if(pg_part->keyorder == 1)
+ 				{
+ 					keyorder = 0;
+ 
+ 					/* Set the ptr to first value. */
+ 					minIndexPrev = part->prev->partitionCheck->min_value->head;
+ 					maxIndexPrev = part->prev->partitionCheck->max_value->head;
+ 					minIndexAfter = part->after->partitionCheck->min_value->head;
+ 					maxIndexAfter = part->after->partitionCheck->max_value->head;
+ 				}
+ 			
+ 				/* Get the name of partition key column */
+ 				partitionColumn = get_attname (rel->rd_id, pg_part->partkey);	
+ 
+ 				/* Get len and typbyval from pg_type */
+ 				get_typlenbyval(pg_part->keytype, &len, &typbyval);
+ 
+ 				typ_oid = pg_part->keytype;
+ 
+ 				/* Is this a valid range? */	
+ 				IsValidRange(minIndexPrev, maxIndexPrev, RelationGetRelid(rel), partitionColumn, part->prev->partName->relname);			
+ 				IsValidRange(minIndexAfter, maxIndexAfter, RelationGetRelid(rel), partitionColumn, part->prev->partName->relname);			
+ 
+ 				resetStringInfo(func_constraint);
+ 
+ 				appendStringInfo(func_constraint, "ALTER TABLE %s DROP CONSTRAINT %s_%s_check; ", 
+ 						part->prev->partName->relname, 
+ 						part->prev->partName->relname, 
+ 						partitionColumn);
+ 
+ 				/* Parse the above SQL string and use this parsetree to create check constraint on child tables. */
+ 				query_list  = pg_parse_query(func_constraint->data);
+ 				parsetree = (Node *)lfirst(list_head(query_list));
+ 				AlterTable(( AlterTableStmt * )parsetree);
+ 
+ 				AddCheckConstraint(typ_oid, 
+ 					((Const *)lfirst(minIndexAfter))->constvalue, 
+ 					((Const *)lfirst(maxIndexAfter))->constvalue, 
+ 					part->prev->partName->relname, 
+ 					partitionColumn);	
+ 
+ 				keycmp_oid = OperatorGet(">=", PG_CATALOG_NAMESPACE , pg_part->keytype, pg_part->keytype, &isdef);
+ 
+ 				if(isdef == FALSE)
+ 					elog(ERROR, "'>=' operator is not defined for this type.");
+ 
+ 				keycmp_proc = get_opcode(keycmp_oid);
+ 				gte_max = DatumGetBool(OidFunctionCall2(keycmp_proc, ((Const *)lfirst(maxIndexAfter))->constvalue, ((Const *)lfirst(maxIndexPrev))->constvalue));
+ 
+ 				if(gte_max == false)
+ 					elog(ERROR, "Range of partition can only be extended.");
+ 
+ 				keycmp_oid = OperatorGet("<=", PG_CATALOG_NAMESPACE , pg_part->keytype, pg_part->keytype, &isdef);
+ 
+ 				if(isdef == FALSE)
+ 					elog(ERROR, "'<=' operator is not defined for this type.");
+ 
+ 				keycmp_proc = get_opcode(keycmp_oid);
+ 				lte_min = DatumGetBool(OidFunctionCall2(keycmp_proc, ((Const *)lfirst(minIndexAfter))->constvalue, ((Const *)lfirst(minIndexPrev))->constvalue));
+ 
+ 				if(lte_min == false)
+ 					elog(ERROR, "Range of partition can only be extended.");
+ 
+ 				/* Delete the row. */
+ 				simple_heap_delete(pg_partrel, &pg_parttup->t_self);
+ 
+ 				/* Insert the new updated row. */
+ 
+ 				WriteRangePartitionToCatalog(((Const *)lfirst(minIndexAfter))->constvalue,
+ 					((Const *)lfirst(maxIndexAfter))->constvalue,
+ 					len,
+ 					typbyval,
+ 					RelationGetRelid(rel),
+ 					relId,
+ 					get_attnum(RelationGetRelid(rel), partitionColumn),
+ 					typ_oid,
+ 					++keyorder										
+ 					);					
+ 
+ 				minIndexPrev = minIndexPrev->next;
+ 				maxIndexPrev = maxIndexPrev->next;
+ 				minIndexAfter = minIndexAfter->next;
+ 				maxIndexAfter = maxIndexAfter->next;
+ 			}
+ 			else
+ 			{
+ 				if (!list_member_oid(distinct_part_rel_oid_list, pg_part->partrelid))
+ 				{
+ 					distinct_part_rel_oid_list = lappend_oid(distinct_part_rel_oid_list, pg_part->partrelid);
+ 					childOids[j++] = pg_part->partrelid;
+ 				
+ 					tmp = makeNode(Partition);
+ 					tmp->partName 		= makeNode(RangeVar);
+ 					tmp->partitionCheck	= makeNode(Constraint);
+ 
+ 					/* Add this partition to partition attributes. */
+ 					partition_attr->partitions = lappend(partition_attr->partitions, tmp);
+ 				}
+ 
+ 				Relation tmp_rel = RelationIdGetRelation(pg_part->partrelid);
+ 				tmp->partName->relname = RelationGetRelationName(tmp_rel);
+ 				relation_close(tmp_rel, 0);
+ 
+ 				/* Get the name of partition key column */
+ 				partitionColumn = get_attname (rel->rd_id, pg_part->partkey);	
+ 
+         	    /* Get len and typbyval from pg_type */
+             	get_typlenbyval(pg_part->keytype, &len, &typbyval);
+ 			
+ 	      		/* Get min attribute from catalog */
+ 		        part_attr = heap_getattr (pg_parttup, Anum_pg_partition_minval, pg_partrel->rd_att, &isnull);
+ 
+    			 	/* Three cases a. datatypes with typbyval true and fix length.
+          		 * b. datatypes with byval false and fix length.
+ 	         	 * c. extendible datatypes where length -1.
+     	     	 */
+ 	    	    if ( typbyval )
+     	    	{
+         	    	short_datum = 0;
+ 	            	memcpy(&short_datum, VARDATA_ANY(part_attr), len);
+ 		            part_attr = short_datum;
+     		    }
+         		else if (len != -1)
+ 		        {
+     		        part_attr = (Datum)VARDATA_ANY(part_attr);
+         		}
+ 
+ 				/* Create const. */		
+ 				tmp_const = makeConst(pg_part->keytype,	/* Const type */
+ 										-1,
+ 										len,
+ 										part_attr,
+ 										false,
+ 										typbyval);
+ 
+ 				tmp_const->location = -1;
+ 
+ 				/* Add this to new partition. */
+ 				tmp->partitionCheck->min_value = lappend(tmp->partitionCheck->min_value, tmp_const);
+ 
+        			/* Get min attribute from catalog */
+ 		        part_attr = heap_getattr (pg_parttup, Anum_pg_partition_maxval, pg_partrel->rd_att, &isnull);
+ 
+    			    /* Three cases a. datatypes with typbyval true and fix length.
+         	 	 * b. datatypes with byval false and fix length.
+          		 * c. extendible datatypes where length -1.
+ 	         	 */
+     	    	if ( typbyval )
+         		{
+             		short_datum = 0;
+ 	            	memcpy(&short_datum, VARDATA_ANY(part_attr), len);
+ 	    	        part_attr = short_datum;
+     	    	}
+ 	    	    else if (len != -1)
+     	    	{
+         	    	part_attr = (Datum)VARDATA_ANY(part_attr);
+ 		        }
+ 
+ 				/* Create const. */		
+ 				tmp_const = makeConst(pg_part->keytype,	/* Const type */
+ 										-1,
+ 										len,
+ 										part_attr,
+ 										false,
+ 										typbyval);
+ 
+ 				tmp_const->location = -1;
+ 
+ 				/* Add this to new partition. */
+ 				tmp->partitionCheck->max_value = lappend(tmp->partitionCheck->max_value, tmp_const);
+ 			}
+ 		}
+ 	}
+ 
+ 	childOids[j++] = relId;
+ 	partition_attr->partitions = lappend(partition_attr->partitions, part->after);
+ 
+ 	ValidateRanges(partition_attr, RelationGetRelid(rel), childOids);
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, RowExclusiveLock);
+ }
+ 
+ 
+ static void
+ ATExecDropPartitionByRange(AlteredTableInfo *tab, Relation rel,
+     Partition *part)
+ {
+ 	List		*rows_to_be_deleted_list = NULL;
+ 	ListCell	*row_to_be_deleted;
+ 	List		*distinct_part_key_list= NULL;
+     ScanKeyData	skey;
+     SysScanDesc	pg_partscan;
+     HeapTuple  	pg_parttup;
+     Relation   	pg_partrel;
+ 	StringInfo	query = makeStringInfo();
+ 	Node		*parsetree;
+ 	List		*query_list = NULL;
+ 	char		*partitionColumn;
+ 	int16		len;
+ 	ListCell	*minIndex;
+ 	ListCell	*maxIndex;
+ 	bool		typbyval;
+ 	bool		isnull;
+ 	Datum		min_datum;
+ 	Datum		max_datum;
+ 	Datum		short_datum;
+ 	Oid			keycmp_oid;
+ 	bool		isdef;
+ 	Oid			keycmp_proc;
+ 	bool		lte_min;
+ 	bool		gte_max;
+ 	bool		IsRelDeleted = false;
+ 	PartitionRowInfo	*partRowInfo;	
+ 
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         if(pg_part->parttype == PART_RANGE)
+         {
+ 			if (!list_member_int(distinct_part_key_list, pg_part->partkey))
+ 			{
+ 				distinct_part_key_list = lappend_int(distinct_part_key_list, pg_part->partkey);				
+ 			}	
+ 			if(pg_part->keyorder == 1)
+ 			{
+ 				IsRelDeleted = false;
+ 
+ 				/* Set the ptr to first value. */
+ 				minIndex = part->partitionCheck->min_value->head;
+ 				maxIndex = part->partitionCheck->max_value->head;
+ 
+ 				if(list_length(distinct_part_key_list)== list_length(rows_to_be_deleted_list))
+ 				{
+ 				foreach(row_to_be_deleted, rows_to_be_deleted_list)
+ 				{
+ 					PartitionRowInfo *tmp = (PartitionRowInfo *)lfirst(row_to_be_deleted);
+ 					simple_heap_delete(pg_partrel, &tmp->tid);
+ 
+ 					if(IsRelDeleted == false)
+ 					{
+ 						IsRelDeleted = true;
+ 						resetStringInfo(query);
+ 						Relation Rel = RelationIdGetRelation(tmp->partRelOid);						
+ 						appendStringInfo(query, "DROP TABLE %s CASCADE;", RelationGetRelationName(Rel));
+ 						relation_close(Rel, 0);
+ 						query_list = pg_parse_query(query->data);
+ 						parsetree = (Node *)lfirst(list_head(query_list));
+ 						RemoveRelations((DropStmt *)parsetree);						
+ 					}
+ 
+ 					pfree(tmp);
+ 				}
+ 				}
+ 
+ 				list_free(rows_to_be_deleted_list);
+ 				rows_to_be_deleted_list = NULL;
+ 			}
+ 				
+ 			/* Get the name of partition key column */
+ 			partitionColumn = get_attname (rel->rd_id, pg_part->partkey);	
+ 
+             /* Get len and typbyval from pg_type */
+             get_typlenbyval(pg_part->keytype, &len, &typbyval);
+ 			
+       		/* Get min attribute from catalog */
+ 	        min_datum = heap_getattr (pg_parttup, Anum_pg_partition_minval, pg_partrel->rd_att, &isnull);
+ 
+    		 	/* Three cases a. datatypes with typbyval true and fix length.
+          	 * b. datatypes with byval false and fix length.
+          	 * c. extendible datatypes where length -1.
+          	 */
+ 	        if ( typbyval )
+     	    {
+         	    short_datum = 0;
+             	memcpy(&short_datum, VARDATA_ANY(min_datum), len);
+ 	            min_datum = short_datum;
+     	    }
+         	else if (len != -1)
+ 	        {
+     	        min_datum = (Datum)VARDATA_ANY(min_datum);
+ 			}				
+ 
+       		/* Get max attribute from catalog */
+ 	        max_datum = heap_getattr (pg_parttup, Anum_pg_partition_maxval, pg_partrel->rd_att, &isnull);
+ 
+    		 	/* Three cases a. datatypes with typbyval true and fix length.
+          	 * b. datatypes with byval false and fix length.
+          	 * c. extendible datatypes where length -1.
+          	 */
+ 	        if ( typbyval )
+     	    {
+         	    short_datum = 0;
+             	memcpy(&short_datum, VARDATA_ANY(max_datum), len);
+ 	            max_datum = short_datum;
+     	    }
+         	else if (len != -1)
+ 	        {
+     	        max_datum = (Datum)VARDATA_ANY(max_datum);
+ 			}				
+ 			
+ 			/* Is this a valid range? */	
+ 			IsValidRange(minIndex, maxIndex, RelationGetRelid(rel), partitionColumn, NULL);			
+ 	
+ 			keycmp_oid = OperatorGet("<=", PG_CATALOG_NAMESPACE , pg_part->keytype, pg_part->keytype, &isdef);
+ 
+ 			if(isdef == FALSE)
+ 				elog(ERROR, "'<=' operator is not defined for this type.");
+ 
+ 			keycmp_proc = get_opcode(keycmp_oid);
+ 			lte_min = DatumGetBool(OidFunctionCall2(keycmp_proc, ((Const *)lfirst(minIndex))->constvalue, min_datum));
+ 
+ 			keycmp_oid = OperatorGet(">=", PG_CATALOG_NAMESPACE , pg_part->keytype, pg_part->keytype, &isdef);
+ 
+ 			if(isdef == FALSE)
+ 				elog(ERROR, "'>=' operator is not defined for this type.");
+ 
+ 			keycmp_proc = get_opcode(keycmp_oid);
+ 			gte_max = DatumGetBool(OidFunctionCall2(keycmp_proc, ((Const *)lfirst(maxIndex))->constvalue, max_datum));
+ 
+ 			if(lte_min && gte_max)
+ 			{
+ 				partRowInfo = palloc(sizeof(PartitionRowInfo));
+ 				memcpy(&partRowInfo->tid, &pg_parttup->t_self, sizeof(ItemPointerData));
+ 				partRowInfo->partRelOid = pg_part->partrelid;
+ 				rows_to_be_deleted_list = lappend(rows_to_be_deleted_list, partRowInfo);
+ 			}
+ 			else
+ 			{
+ 				list_free(rows_to_be_deleted_list);
+ 				rows_to_be_deleted_list = NULL;
+ 			}
+ 
+ 
+            	minIndex = minIndex->next;
+             maxIndex = maxIndex->next;
+ 		}
+ 	}
+ 
+ 	IsRelDeleted = false;
+ 	foreach(row_to_be_deleted, rows_to_be_deleted_list)
+ 	{
+ 		PartitionRowInfo *tmp = (PartitionRowInfo *)lfirst(row_to_be_deleted);
+ 		simple_heap_delete(pg_partrel, &tmp->tid);
+ 
+ 		if(IsRelDeleted == false)
+ 		{
+ 			IsRelDeleted = true;
+ 			resetStringInfo(query);
+ 			Relation Rel = RelationIdGetRelation(tmp->partRelOid);						
+ 			appendStringInfo(query, "DROP TABLE %s CASCADE;", RelationGetRelationName(Rel));
+ 			relation_close(Rel, 0);
+ 			query_list = pg_parse_query(query->data);
+ 			parsetree = (Node *)lfirst(list_head(query_list));
+ 			RemoveRelations((DropStmt *)parsetree);						
+ 		}
+ 		pfree(tmp);
+ 	}
+ 	list_free(rows_to_be_deleted_list);
+ 	rows_to_be_deleted_list = NULL;
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, RowExclusiveLock);
+ }
+ 
+ static void 
+ ATExecDropPartitionByName(AlteredTableInfo *tab, Relation rel,
+ 	Partition *part) 
+ {
+ 	Oid			relId = RelnameGetRelid(part->partName->relname);
+     ScanKeyData	skey;
+     SysScanDesc	pg_partscan;
+     HeapTuple  	pg_parttup;
+     Relation   	pg_partrel;
+ 	StringInfo	query = makeStringInfo();
+ 	Node		*parsetree;
+ 	List		*query_list = NULL;
+ 	int			count = 0;
+ 
+ 	if(relId == InvalidOid)
+ 		elog(ERROR, "Error : Could not find valid Rel-Id for '%s' in current search path.", part->partName->relname);
+ 
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_partrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(relId));
+ 
+     pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         if(pg_part->parttype == PART_RANGE)
+         {
+ 			count++;
+ 			simple_heap_delete(pg_partrel, &pg_parttup->t_self);
+ 		}
+ 	}
+ 
+ 	if(count)
+ 	{
+ 		appendStringInfo(query, "DROP TABLE %s CASCADE;", part->partName->relname);
+ 		query_list = pg_parse_query(query->data);
+ 		parsetree = (Node *)lfirst(list_head(query_list));
+ 		RemoveRelations((DropStmt *)parsetree);
+ 	}
+ 	else
+ 	{
+ 		elog(ERROR, "'%s' is not a valid partition of '%s' table.", part->partName->relname, RelationGetRelationName(rel));
+ 	}
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, RowExclusiveLock);
+ }
+ /*
+  * ATExecAddPartition : Add partition to an existing table. Currectly only range partition
+  * is supported.
+  */
+ static Oid 
+ ATExecAddPartition(AlteredTableInfo *tab, 
+ 	Relation rel, Partition *part)
+ {
+ 	StringInfo 		query = makeStringInfo();
+ 	StringInfo		createTrigger = makeStringInfo();
+ 	List			*query_list;
+ 	Node			*parsetree;
+     ScanKeyData 	skey;
+     SysScanDesc 	pg_partscan;
+     HeapTuple   	pg_parttup;
+     Relation    	pg_partrel;
+     List        	*distinct_part_key_list = NULL;	
+ 	List			*distinct_part_rel_oid_list = NULL;
+ 	ListCell		*minIndex, *maxIndex;
+ 	Datum 			min_datum, max_datum;
+ 	Oid 			typ_oid;
+ 	bool 			typbyval;
+ 	int16			len;
+ 	char            *partitionColumn; 
+ 	Partition		*tmp;
+ 	Datum 			part_attr;
+ 	bool 			isnull;
+ 	PartitionAttrs	*partition_attr;
+ 	int				partitionCount = 0;
+ 	Oid				*childOids = NULL;
+ 	int				j = 0;
+ 	Oid				child;
+ 	Const			*tmp_const;
+ 
+ 	if(part->partName)
+ 	{
+ 		if(part->tablespacename)
+ 			appendStringInfo(query, "CREATE TABLE %s () INHERITS (%s) TABLESPACE %s;", part->partName->relname, RelationGetRelationName(rel), part->tablespacename);
+ 		else
+ 			appendStringInfo(query, "CREATE TABLE %s () INHERITS (%s) ;", part->partName->relname, RelationGetRelationName(rel));
+ 	}
+ 	else
+ 	{
+ 		elog(ERROR, "Please specify partition name.");
+ 	}
+ 
+ 	query_list  = pg_parse_query(query->data);
+ 	parsetree = (Node *)lfirst(list_head(query_list));
+ 
+ 	child = DefineRelation((CreateStmt *)parsetree, RELKIND_RELATION);
+ 
+ 	minIndex = part->partitionCheck->min_value->head;
+ 	maxIndex = part->partitionCheck->max_value->head;
+ 
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+ 	/* Create partition attribute node. */
+ 	partition_attr = makeNode(PartitionAttrs);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+ 
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         if(pg_part->parttype == PART_RANGE)
+         {
+ 			partitionCount++;
+ 			if (!list_member_int(distinct_part_key_list, pg_part->partkey))
+ 			{
+ 
+ 				Alias *colName = NULL;
+ 
+ 				distinct_part_key_list = lappend_int(distinct_part_key_list, pg_part->partkey);
+ 
+ 				/* Get the name of partition key column */
+ 				partitionColumn = get_attname (rel->rd_id, pg_part->partkey);
+ 
+ 				/* Add the partition key columns. */
+ 				colName = makeAlias(partitionColumn, NULL);
+ 				partition_attr->colName = lappend(partition_attr->colName, colName);
+ 
+ 				IsValidRange(minIndex, maxIndex, RelationGetRelid(rel), partitionColumn, part->partName->relname);				
+ 
+ 				AddCheckConstraint(pg_part->keytype, 
+ 					((Const *)lfirst(minIndex))->constvalue, 
+ 					((Const *)lfirst(maxIndex))->constvalue, 
+ 					part->partName->relname, 
+ 					partitionColumn);	
+ 
+             	minIndex = minIndex->next;
+ 	            maxIndex = maxIndex->next;
+ 			}
+ 		}
+ 	}
+ 
+ 	if(partitionCount == 0)
+ 		elog(ERROR, "Could not find partition attributes of '%s'.", RelationGetRelationName(rel));
+ 
+ 	if(minIndex != NULL || maxIndex != NULL)
+        	elog(ERROR, "Multiple values specified for partition attributes for partition '%s'.", part->partName->relname);
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, AccessShareLock);
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+ //	partition_attr->PartitionFunction = PART_RANGE;
+ 
+ 	if((partitionCount % list_length(distinct_part_key_list))==0)
+ 	{
+ 		childOids = malloc(sizeof(Oid) * (1 + (partitionCount/list_length(distinct_part_key_list))));
+ 	}
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+ 		Datum short_datum;
+ 
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         if(pg_part->parttype == PART_RANGE)
+         {
+ 
+ 			if (!list_member_oid(distinct_part_rel_oid_list, pg_part->partrelid))
+ 			{
+ 				distinct_part_rel_oid_list = lappend_oid(distinct_part_rel_oid_list, pg_part->partrelid);
+ 				childOids[j++] = pg_part->partrelid;
+ 				
+ 				tmp = makeNode(Partition);
+ 				tmp->partName 		= makeNode(RangeVar);
+ 				tmp->partitionCheck	= makeNode(Constraint);
+ 
+ 				/* Add this partition to partition attributes. */
+ 				partition_attr->partitions = lappend(partition_attr->partitions, tmp);
+ 			}
+ 
+ 			Relation tmp_rel = RelationIdGetRelation(pg_part->partrelid);
+ 			tmp->partName->relname = RelationGetRelationName(tmp_rel);
+ 			relation_close(tmp_rel, 0);
+ 
+ 			/* Get the name of partition key column */
+ 			partitionColumn = get_attname (rel->rd_id, pg_part->partkey);	
+ 
+             /* Get len and typbyval from pg_type */
+             get_typlenbyval(pg_part->keytype, &len, &typbyval);
+ 			
+       		/* Get min attribute from catalog */
+ 	        part_attr = heap_getattr (pg_parttup, Anum_pg_partition_minval, pg_partrel->rd_att, &isnull);
+ 
+    		 	/* Three cases a. datatypes with typbyval true and fix length.
+          	 * b. datatypes with byval false and fix length.
+          	 * c. extendible datatypes where length -1.
+          	 */
+ 	        if ( typbyval )
+     	    {
+         	    short_datum = 0;
+             	memcpy(&short_datum, VARDATA_ANY(part_attr), len);
+ 	            part_attr = short_datum;
+     	    }
+         	else if (len != -1)
+ 	        {
+     	        part_attr = (Datum)VARDATA_ANY(part_attr);
+         	}
+ 
+ 
+ 			/* Create const. */		
+ 			tmp_const = makeConst(pg_part->keytype,	/* Const type */
+ 									-1,
+ 									len,
+ 									part_attr,
+ 									false,
+ 									typbyval);
+ 
+ 			tmp_const->location = -1;
+ 
+ 			/* Add this to new partition. */
+ 			tmp->partitionCheck->min_value = lappend(tmp->partitionCheck->min_value, tmp_const);
+ 
+        		/* Get min attribute from catalog */
+ 	        part_attr = heap_getattr (pg_parttup, Anum_pg_partition_maxval, pg_partrel->rd_att, &isnull);
+ 
+    		    /* Three cases a. datatypes with typbyval true and fix length.
+          	 * b. datatypes with byval false and fix length.
+          	 * c. extendible datatypes where length -1.
+          	 */
+         	if ( typbyval )
+         	{
+             	short_datum = 0;
+ 	            memcpy(&short_datum, VARDATA_ANY(part_attr), len);
+     	        part_attr = short_datum;
+         	}
+ 	        else if (len != -1)
+     	    {
+         	    part_attr = (Datum)VARDATA_ANY(part_attr);
+ 	        }
+ 
+ 			/* Create const. */		
+ 			tmp_const = makeConst(pg_part->keytype,	/* Const type */
+ 									-1,
+ 									len,
+ 									part_attr,
+ 									false,
+ 									typbyval);
+ 
+ 			tmp_const->location = -1;
+ 
+ 			/* Add this to new partition. */
+ 			tmp->partitionCheck->max_value = lappend(tmp->partitionCheck->max_value, tmp_const);
+ 		}
+ 	}	
+ 
+ 	childOids[j++] = child;
+ 	partition_attr->partitions = lappend(partition_attr->partitions, part);
+ 
+ 	ValidateRanges(partition_attr, RelationGetRelid(rel), childOids);
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, AccessShareLock);
+ 
+ 	minIndex = part->partitionCheck->min_value->head;
+ 	maxIndex = part->partitionCheck->max_value->head;
+ 
+ 
+ 	ListCell *partColumn;
+ 
+ 	j = 0;
+ 
+ 	foreach(partColumn, partition_attr->colName)
+ 	{
+ 		/* Get the name of partition key column. */
+ 		partitionColumn = ((Alias *)lfirst(partColumn))->aliasname;
+ 
+         min_datum = ((Const *)lfirst(minIndex))->constvalue;  
+         max_datum = ((Const *)lfirst(maxIndex))->constvalue;  
+ 
+         /* Get the attribute type. */
+         typ_oid = get_atttype(RelationGetRelid(rel), get_attnum(RelationGetRelid(rel), partitionColumn) );
+ 
+ 		/* Get the attribute length*/
+ 		get_typlenbyval(typ_oid, &len, &typbyval);
+ 
+ 		WriteRangePartitionToCatalog(min_datum, 
+ 										max_datum,
+ 										len,
+ 										typbyval,
+ 										RelationGetRelid(rel),
+ 										child,
+ 										get_attnum(RelationGetRelid(rel), partitionColumn),
+ 										typ_oid,
+ 										++j);
+ 
+        	minIndex = minIndex->next;
+         maxIndex = maxIndex->next;
+ 	}
+ 
+     resetStringInfo(createTrigger);
+     appendStringInfo(createTrigger, "CREATE TRIGGER zz_partition_update_trigger BEFORE UPDATE ON %s ", part->partName->relname);
+     appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_update_trigger ();");
+ 
+     /* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+     query_list  = pg_parse_query(createTrigger->data);
+     parsetree = (Node *)lfirst(list_head(query_list));
+     CreateTrigger((CreateTrigStmt * )parsetree, 0);
+ 
+ 	return child;
+ }
+ 
+ 
  static void
  ATExecAddColumn(AlteredTableInfo *tab, Relation rel,
  				ColumnDef *colDef)
